无法捕获异常:Java关于在catch中抛出一个异常给外围函数却捕获不到该异常的思考

先给出一串代码:

public class TestException {
	public TestException(){
	}
	
	boolean testEx()throws Exception{
		boolean ret=true;
		try{
			ret=testEx1();
		}
		catch(Exception e){
			System.out.println("testEx, catch exception");
			ret=false;
			throw e;
		}
		finally{
			System.out.println("testEx, finally:return value:"+ret);
			return ret;
		}
	}
	
	boolean testEx1()throws Exception{
		boolean ret=true;
		try{
			ret=testEx2();
			if(!ret){
				return false;
			}
			System.out.println("testEx1, at the end of try");
			return ret;
		}
		catch(Exception e){
			System.out.println("testEx1, catch exception");
			ret=false;
			throw e;
		}
		finally{
			System.out.println("testEx1, finally:return value:"+ret);
			return ret;
		}
	}
	
	boolean testEx2()throws Exception{
		boolean ret=true;
		try{
			int b=12;
			int c;
			for(int i=2;i>=-2;i--){
				c=b/i;
				System.out.println("i="+i);
			}
			return true;
		}
		catch(Exception e){
			System.out.println("testEx2, catch exception");
			ret=false;
			throw e;
		}
		finally {
			System.out.println("testEx2, finally:return value="+ret);
			return ret;
		}
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		TestException testException1=new TestException();
		try{
			testException1.testEx();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

}

对于函数testEx2()中catch块中抛出的异常,testEx1()函数却捕获不到,这是为什么呢?
我想过一种可能:testEx1()中将testEx2()的返回值赋值给ret,即 ret=testEx2(),而testEx2()中抛出的异常在这个过程中被过滤掉了。因为如果我直接把testEx2()放在testEx1()中,而不是通过ret=testEx2()的方式,那么这个异常是能够被捕获的。

原先,我也在网上向别人求证这个想法,也通过调试想验证这个想法,但显然是无意义的,这个问题已经很明确了,这个想法已无可挑剔。

为什么这么说呢?首先,我们调试发现这个捕获不到的异常其实已经不存在了,因为当我们运行ret=testEx2()这条语句时,我们实际上是将一个值赋给一个变量,而原先testEx2()里的代码已经不存在了,也就是说,在testEx1()函数中,testEx2()本就不存在,可以理解为testEx1()只是将testEx2()当作工具使用,并将用其所获取的值赋给了变量ret,仅此而已。

阅读更多
版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/YaoDeBiAn/article/details/62056701
个人分类: java 编程
想对作者说点什么? 我来说一句

没有更多推荐了,返回首页

关闭
关闭
关闭